{"openapi":"3.0.2","info":{"title":"5GASP CI_CD_Manager","description":"REST API of the 5GASP CI_CD_Manager","version":"0.0.1"},"paths":{"/testbeds/all":{"get":{"tags":["testbeds"],"summary":"Get all testbeds","description":"Get all the testbeds available.","operationId":"all_testbeds_testbeds_all_get","responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{}}}}}}},"/tests/all":{"get":{"tags":["tests"],"summary":"Get all tests","description":"This endpoint provides a list of all the tests that exist in the database.","operationId":"all_tests_tests_all_get","responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{}}}}}}},"/tests/per-testbed":{"get":{"tags":["tests"],"summary":"Get testbed's tests","description":"The developers may use this endpoint to get a listing of all the standard tests provided by a testbed.","operationId":"tests_per_testbed_tests_per_testbed_get","parameters":[{"required":true,"schema":{"title":"Testbed","type":"string"},"name":"testbed","in":"query"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/tests/test-status":{"get":{"tags":["tests"],"summary":"Get the status of test","description":"The developers/apis/web_ui uses this endpoint to gather the status of a test","operationId":"get_test_status_tests_test_status_get","parameters":[{"required":true,"schema":{"title":"Netapp Id","type":"string"},"name":"netapp_id","in":"query"},{"required":true,"schema":{"title":"Network Service Id","type":"string"},"name":"network_service_id","in":"query"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}},"post":{"tags":["tests"],"summary":"Update the status of a test","description":"When the CI Agent is performing the tests, it will use this endpoint to update their status.","operationId":"update_test_status_tests_test_status_post","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Test_Status_Update"}}},"required":true},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/tests/new":{"post":{"tags":["tests"],"summary":"Create a new test","description":"Given a file with a test descriptor, create a new test.","operationId":"new_test_tests_new_post","requestBody":{"content":{"multipart/form-data":{"schema":{"$ref":"#/components/schemas/Body_new_test_tests_new_post"}}},"required":true},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/nodes/new":{"post":{"tags":["agents"],"summary":"Register new CI/CD Agent","description":"When the CI/CD Agent is deployed (via a VNF) it registers itself in the CI_CD_Manager, via this endpoint.","operationId":"create_node_nodes_new_post","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CI_CD_Node_Create"}}},"required":true},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CI_CD_Node"}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}},"/nodes/all":{"get":{"tags":["agents"],"summary":"Get all CI/CD Agents","description":"Using this endpoint is possible to obtain a list of all the CI/CD Agents.","operationId":"get_nodes_nodes_all_get","parameters":[{"required":false,"schema":{"title":"Skip","type":"integer","default":0},"name":"skip","in":"query"},{"required":false,"schema":{"title":"Limit","type":"integer","default":500},"name":"limit","in":"query"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"title":"Response Get Nodes Nodes All Get","type":"array","items":{"$ref":"#/components/schemas/CI_CD_Node"}}}}},"422":{"description":"Validation Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}}}}}}},"components":{"schemas":{"Body_new_test_tests_new_post":{"title":"Body_new_test_tests_new_post","required":["test_descriptor"],"type":"object","properties":{"test_descriptor":{"title":"Test Descriptor","type":"string","format":"binary"}}},"CI_CD_Node":{"title":"CI_CD_Node","required":["ip","netapp_id","network_service_id","username","testbed_id","is_online","id","communication_token"],"type":"object","properties":{"ip":{"title":"Ip","type":"string"},"netapp_id":{"title":"Netapp Id","type":"string"},"network_service_id":{"title":"Network Service Id","type":"string"},"username":{"title":"Username","type":"string"},"testbed_id":{"title":"Testbed Id","type":"string"},"is_online":{"title":"Is Online","type":"boolean"},"id":{"title":"Id","type":"integer"},"communication_token":{"title":"Communication Token","type":"string"}}},"CI_CD_Node_Create":{"title":"CI_CD_Node_Create","required":["ip","netapp_id","network_service_id","username","testbed_id","is_online","password"],"type":"object","properties":{"ip":{"title":"Ip","type":"string"},"netapp_id":{"title":"Netapp Id","type":"string"},"network_service_id":{"title":"Network Service Id","type":"string"},"username":{"title":"Username","type":"string"},"testbed_id":{"title":"Testbed Id","type":"string"},"is_online":{"title":"Is Online","type":"boolean"},"password":{"title":"Password","type":"string"}}},"HTTPValidationError":{"title":"HTTPValidationError","type":"object","properties":{"detail":{"title":"Detail","type":"array","items":{"$ref":"#/components/schemas/ValidationError"}}}},"Test_Status_Update":{"title":"Test_Status_Update","required":["test_id","state","success","communication_token"],"type":"object","properties":{"test_id":{"title":"Test Id","type":"integer"},"state":{"title":"State","type":"string"},"success":{"title":"Success","type":"boolean"},"communication_token":{"title":"Communication Token","type":"string"}}},"ValidationError":{"title":"ValidationError","required":["loc","msg","type"],"type":"object","properties":{"loc":{"title":"Location","type":"array","items":{"type":"string"}},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}}}}},"tags":[{"name":"agents","description":"Operations related with the CI/CD Agents."},{"name":"tests","description":"Operations related with the tests performed on the NetApps."},{"name":"testbeds","description":"Operations related with the testbeds."}]}